#include "hoc.h"
#include "hoc.tab.h"
dbl integer(dbl);

static struct {
    char* name;
    dbl cval;
} consts[] = {
    {"PI",     3.14159265358979323846},
    {"E" ,     2.71828182845904523536},
    {"GAMMA",  0.57721566490153286060},
    {"DEG",   57.29577951308232087680},
    {0,        0}
} ;

static struct {
    char *name ;
    dbl (*func)( dbl );
} builtins[] = {
    {"sin",   sin},
    {"cos",   cos},
    {"atan",  atan},
    {"log",   log},
    {"exp",   exp},
    {"sqrt",  sqrt},
    {"abs",   fabs},
    {"int",   integer},
    {0,       0}
};

void init( void )
{
    int i;
    symbol* s;

    for (i = 0 ; consts[i].name ; i++) {
        install( consts[i].name, VAR, consts[i].cval );
    }
    for (i = 0 ; builtins[i].name ; i++) {
        s = install(builtins[i].name, BLTIN, 0.0);
        s->u.ptr = builtins[i].func;
    }
}

dbl integer(dbl x)
{
    return (dbl)(long) x;
}
